--- /Users/markus/devel/freecad/FreeCAD-git/src/Mod/Path/PathScripts/PathFeatureExtensions.py	2021-07-15 01:08:17.000000000 +0800
+++ PathFeatureExtensions.py	2021-07-15 22:26:02.000000000 +0800
@@ -328,7 +328,13 @@
 
                 # assuming the offset produces a valid circle - go for it
                 if r > 0:
-                    e3 = Part.makeCircle(r, circle.Center, circle.Axis, edge.FirstParameter * 180 / math.pi-90, edge.LastParameter * 180 / math.pi-90)
+                    if (abs(circle.Rotation.toEuler()[2]-180)<1e-5): # we really only support horizontal milling...
+                       negative=-1
+                    else:
+                       negative=1
+                    offdeg1=edge.FirstParameter * 180 / math.pi+circle.Rotation.toEuler()[0]*negative
+                    offdeg2=edge.LastParameter * 180 / math.pi+circle.Rotation.toEuler()[0]*negative
+                    e3 = Part.makeCircle(r, circle.Center, circle.Axis, offdeg1, offdeg2)
                     if endPoints(edge):
                         # need to construct the arc slice
                         e0 = Part.makeLine(edge.valueAt(edge.FirstParameter), e3.valueAt(e3.FirstParameter))
